﻿using System.Collections.Generic;
using System.Data;
using System.Data.OleDb;
/**
 * Jan Lorenz, 30.03.2011
 **/
namespace MtSql.Oledb
{
    public static class OleDBExtensions
    {
        /// <summary>
        /// Chainable, Adds a new OledbParameter to the List
        /// </summary>
        public static List<OleDbParameter> AddParameter(this List<OleDbParameter> ps, object value)
        {
            ps.Add(new OleDbParameter(string.Empty, value));
            return ps;
        }

        /// <summary>
        /// Chainable, Adds a new OledbParameter to the List
        /// </summary>
        public static List<OleDbParameter> AddParameter(this List<OleDbParameter> ps, string name, object value)
        {
            ps.Add(new OleDbParameter(name, value));
            return ps;
        }

        /// <summary>
        /// Chainable, Adds a new OledbParameter to the List
        /// </summary>
        public static List<OleDbParameter> AddParameter(this List<OleDbParameter> ps, string name, OleDbType type, object value)
        {
            OleDbParameter p = new OleDbParameter(name, type);
            p.Value = value;
            ps.Add(p);
            return ps;
        }

        /// <summary>
        /// Chainable, Adds a new OledbParameter to the List
        /// </summary>
        public static List<OleDbParameter> AddParameter(this List<OleDbParameter> ps, string name, OleDbType type, int size, object value)
        {
            OleDbParameter p = new OleDbParameter(name, type, size);
            p.Value = value;
            ps.Add(p);
            return ps;
        }

        /// <summary>
        /// Chainable, Adds a new Oledb-OutParameter to the List
        /// </summary>
        public static List<OleDbParameter> AddOutParameter(this List<OleDbParameter> ps, string name, object value, out OleDbParameter outParam)
        {
            outParam = new OleDbParameter(name, value);
            outParam.Direction = ParameterDirection.Output;
            ps.Add(outParam);
            return ps;
        }

        /// <summary>
        /// Chainable, Adds a new Oledb-OutParameter to the List
        /// </summary>
        public static List<OleDbParameter> AddOutParameter(this List<OleDbParameter> ps, string name, OleDbType type, object value, out OleDbParameter outParam)
        {
            outParam = new OleDbParameter(name, type);
            outParam.Direction = ParameterDirection.Output;
            outParam.Value = value;
            ps.Add(outParam);
            return ps;
        }

        /// <summary>
        /// Chainable, Adds a new Oledb-OutParameter to the List
        /// </summary>
        public static List<OleDbParameter> AddOutParameter(this List<OleDbParameter> ps, string name, OleDbType type, int size, object value, out OleDbParameter outParam)
        {
            outParam = new OleDbParameter(name, type, size);
            outParam.Direction = ParameterDirection.Output;
            outParam.Value = value;
            ps.Add(outParam);
            return ps;
        }
    }
}
