﻿using System.Collections.Generic;
using System.Data;
using System.Data.SQLite;

namespace MtSql.SqLite
{
    public static class SqliteExtensions
    {
        public static List<SQLiteParameter> AddParameter(this List<SQLiteParameter> ps, object value)
        {
            ps.Add(new SQLiteParameter(string.Empty, value));
            return ps;
        }

        public static List<SQLiteParameter> AddParameter(this List<SQLiteParameter> ps, string name, object value)
        {
            ps.Add(new SQLiteParameter(name, value));
            return ps;
        }

        public static List<SQLiteParameter> AddParameter(this List<SQLiteParameter> ps, string name, SqlDbType type, object value)
        {
            SQLiteParameter p = new SQLiteParameter(name, type);
            p.Value = value;
            ps.Add(p);
            return ps;
        }

        public static List<SQLiteParameter> AddParameter(this List<SQLiteParameter> ps, string name, SqlDbType type, int size, object value)
        {
            SQLiteParameter p = new SQLiteParameter(name, type);
            p.Size = size;
            p.Value = value;
            ps.Add(p);
            return ps;
        }

        public static List<SQLiteParameter> AddOutParameter(this List<SQLiteParameter> ps, string name, object value, out SQLiteParameter outParam)
        {
            outParam = new SQLiteParameter(name, value);
            outParam.Direction = ParameterDirection.Output;
            ps.Add(outParam);
            return ps;
        }

        public static List<SQLiteParameter> AddOutParameter(this List<SQLiteParameter> ps, string name, SqlDbType type, object value, out SQLiteParameter outParam)
        {
            outParam = new SQLiteParameter(name, type);
            outParam.Direction = ParameterDirection.Output;
            outParam.Value = value;
            ps.Add(outParam);
            return ps;
        }

        public static List<SQLiteParameter> AddOutParameter(this List<SQLiteParameter> ps, string name, SqlDbType type, int size, object value, out SQLiteParameter outParam)
        {
            outParam = new SQLiteParameter(name, type);
            outParam.Size = size;
            outParam.Direction = ParameterDirection.Output;
            outParam.Value = value;
            ps.Add(outParam);
            return ps;
        }
    }
}
