﻿using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
/**
 * Jan Lorenz, 30.03.2011
 * Last Change: 30.11.2011
 **/
namespace MtSql.SqlClient
{
    public static class SqlDbExtensions
    {
        public static List<SqlParameter> AddParameter(this List<SqlParameter> ps, object value)
        {
            ps.Add(new SqlParameter(string.Empty, value));
            return ps;
        }

        public static List<SqlParameter> AddParameter(this List<SqlParameter> ps, string name, object value)
        {
            ps.Add(new SqlParameter(name, value));
            return ps;
        }

        public static List<SqlParameter> AddParameter(this List<SqlParameter> ps, string name, SqlDbType type, object value)
        {
            SqlParameter p = new SqlParameter(name, type);
            p.Value = value;
            ps.Add(p);
            return ps;
        }

        public static List<SqlParameter> AddParameter(this List<SqlParameter> ps, string name, SqlDbType type, int size, object value)
        {
            SqlParameter p = new SqlParameter(name, type, size);
            p.Value = value;
            ps.Add(p);
            return ps;
        }

        public static List<SqlParameter> AddOutParameter(this List<SqlParameter> ps, string name, object value, out SqlParameter outParam)
        {
            outParam = new SqlParameter(name, value);
            outParam.Direction = ParameterDirection.Output;
            ps.Add(outParam);
            return ps;
        }

        public static List<SqlParameter> AddOutParameter(this List<SqlParameter> ps, string name, SqlDbType type, object value, out SqlParameter outParam)
        {
            outParam = new SqlParameter(name, type);
            outParam.Direction = ParameterDirection.Output;
            outParam.Value = value;
            ps.Add(outParam);
            return ps;
        }

        public static List<SqlParameter> AddOutParameter(this List<SqlParameter> ps, string name, SqlDbType type, int size, object value, out SqlParameter outParam)
        {
            outParam = new SqlParameter(name, type, size);
            outParam.Direction = ParameterDirection.Output;
            outParam.Value = value;
            ps.Add(outParam);
            return ps;
        }
    }
}
