﻿using System.Collections.Generic;
using System.Data;

namespace MtSql
{
    public delegate bool RowCallback(LockableDictionary<string, int> columns, object[] row);

    public interface IDataSource<TParameter>
    {
        int ExecuteSqlCommand(string command);
        int ExecuteSqlCommand(string sqlCommand, List<TParameter> parameters);
        int ExecuteSqlCommand(string sqlCommand, CommandType type, List<TParameter> parameters);

        void ExecuteReader(string sqlCommand, RowCallback callback);
        void ExecuteReader(string sqlCommand, CommandType type, RowCallback callback);
        void ExecuteReader(string sqlCommand, CommandType type, List<TParameter> parameters, RowCallback callback);
    }
}
