﻿using System;
using System.Collections.Generic;
using System.Data;

namespace MtSql
{
    //TODO: Test Transaction support
    public class MtTransaction<TConnection, TTransaction, TCommand, TParameter> : DataSourceBase<TCommand, TParameter>
        where TConnection : IDbConnection
        where TCommand : IDbCommand
        where TTransaction : IDbTransaction
        where TParameter : IDataParameter
    {
        internal readonly TConnection Connection;
        internal readonly TTransaction Transaction;
        internal readonly Func<TConnection, TTransaction, TCommand> _CreateCommand;

        internal MtTransaction(TConnection connection, IsolationLevel level, Func<TConnection, TTransaction, TCommand> createCommand)
        {
            this._CreateCommand = createCommand;
            this.Connection = connection;
            this.Transaction = (TTransaction)connection.BeginTransaction(level);
        }

        #region Support Methods

        protected override TCommand GetCommand(string command, CommandType type, List<TParameter> parameters)
        {
            TCommand cmd = _CreateCommand(Connection, Transaction);
            foreach (var p in parameters)
                cmd.Parameters.Add(p);
            cmd.CommandType = type;
            cmd.CommandText = command;
            return cmd;
        }

        protected override void CloseCommand(IDbCommand cmd)
        {
            cmd.Dispose();
        }

        #endregion
    }
}
